
-- ===================================
--              CONSTANTS
-- ===================================
-- Bindings
ID_SERIAL       = 1
ID_LINK         = 2

-- Properties
BRIDGEID      = "Bridge ID"
DEBUG       = "Debug Mode"

-- Timers
Timers = {}
TIMER_DEBUG = "TimerDebug"

-- Table serial commands
T_O             = 1     -- Open
T_C             = 2     -- Close
T_PA            = 4     -- Preset A
T_PB            = 8     -- Preset B
T_PC            = 12    -- Preset C
T_P1      = 06  -- Preset 1/ Blackout For Tandem
T_P2      = 07  -- Preset 2/ Sheer for Tandem
T_P3      = 09  -- Preset 3
T_P4      = 10  -- Preset 4
T_P5      = 11  -- Preset 5
T_P6      = 13  -- Preset 6
T_P7      = 14  -- Preset 7                              
-- General
CHANNEL         = "Channel"
COMMAND         = "Command"
SHADE_COMMAND   = "ShadeCommand"

tChannel = {}
tChannel[1]  = {[T_O] = 'fc', [T_C] = 'ff', [T_PA] = 'f9', [T_PB] = 'f5', [T_PC] = 'f1', [T_P1] = 'fb', [T_P2] = 'fa', [T_P3] = 'f4', [T_P4] = 'f7', [T_P5] = 'f6', [T_P6] = 'fd', [T_P7] = 'f3',}
tChannel[2]  = {[T_O] = 'ff', [T_C] = 'fc', [T_PA] = 'fa', [T_PB] = 'f6', [T_PC] = 'f2', [T_P1] = 'f8', [T_P2] = 'f9', [T_P3] = 'f7', [T_P4] = 'f4', [T_P5] = 'f5', [T_P6] = 'f3', [T_P7] = 'f0',}
tChannel[3]  = {[T_O] = 'fe', [T_C] = 'fd', [T_PA] = 'fb', [T_PB] = 'f7', [T_PC] = 'f3', [T_P1] = 'f9', [T_P2] = 'f8', [T_P3] = 'f6', [T_P4] = 'f5', [T_P5] = 'f4', [T_P6] = 'f2', [T_P7] = 'f1',}
tChannel[4]  = {[T_O] = 'f9', [T_C] = 'fa', [T_PA] = 'fc', [T_PB] = 'f0', [T_PC] = 'f4', [T_P1] = 'fe', [T_P2] = 'ff', [T_P3] = 'f1', [T_P4] = 'f2', [T_P5] = 'f3', [T_P6] = 'f5', [T_P7] = 'f6',}
tChannel[5]  = {[T_O] = 'f8', [T_C] = 'fb', [T_PA] = 'fd', [T_PB] = 'f1', [T_PC] = 'f5', [T_P1] = 'ff', [T_P2] = 'fe', [T_P3] = 'f0', [T_P4] = 'f3', [T_P5] = 'f2', [T_P6] = 'f4', [T_P7] = 'f7',}
tChannel[6]  = {[T_O] = 'fb', [T_C] = 'f8', [T_PA] = 'fe', [T_PB] = 'f2', [T_PC] = 'f6', [T_P1] = 'fc', [T_P2] = 'fd', [T_P3] = 'f3', [T_P4] = 'fd', [T_P5] = 'f1', [T_P6] = 'f7', [T_P7] = 'f4',}
tChannel[7]  = {[T_O] = 'fa', [T_C] = 'f9', [T_PA] = 'ff', [T_PB] = 'f3', [T_PC] = 'f7', [T_P1] = 'fd', [T_P2] = 'fc', [T_P3] = 'f2', [T_P4] = 'f1', [T_P5] = 'f0', [T_P6] = 'f6', [T_P7] = 'f5',}
tChannel[8]  = {[T_O] = 'f5', [T_C] = 'f6', [T_PA] = 'f0', [T_PB] = 'fc', [T_PC] = 'f8', [T_P1] = 'f2', [T_P2] = 'f3', [T_P3] = 'fd', [T_P4] = 'fe', [T_P5] = 'ff', [T_P6] = 'f9', [T_P7] = 'fa',}
tChannel[9]  = {[T_O] = 'f4', [T_C] = 'f7', [T_PA] = 'f1', [T_PB] = 'fd', [T_PC] = 'f9', [T_P1] = 'f3', [T_P2] = 'f2', [T_P3] = 'fc', [T_P4] = 'ff', [T_P5] = 'fe', [T_P6] = 'f8', [T_P7] = 'fb',}
tChannel[10] = {[T_O] = 'f7', [T_C] = 'f4', [T_PA] = 'f2', [T_PB] = 'fe', [T_PC] = 'fa', [T_P1] = 'f0', [T_P2] = 'f1', [T_P3] = 'ff', [T_P4] = 'fc', [T_P5] = 'fd', [T_P6] = 'fb', [T_P7] = 'f8',}
tChannel[11] = {[T_O] = 'f6', [T_C] = 'f5', [T_PA] = 'f3', [T_PB] = 'ff', [T_PC] = 'fb', [T_P1] = 'f1', [T_P2] = 'f0', [T_P3] = 'fe', [T_P4] = 'fd', [T_P5] = 'fc', [T_P6] = 'fa', [T_P7] = 'f9',}
tChannel[12] = {[T_O] = 'f1', [T_C] = 'f2', [T_PA] = 'f4', [T_PB] = 'f8', [T_PC] = 'fc', [T_P1] = 'f6', [T_P2] = 'f7', [T_P3] = 'f9', [T_P4] = 'fa', [T_P5] = 'fb', [T_P6] = 'fd', [T_P7] = 'fe',}
tChannel[13] = {[T_O] = 'f0', [T_C] = 'f3', [T_PA] = 'f5', [T_PB] = 'f9', [T_PC] = 'fd', [T_P1] = 'f7', [T_P2] = 'f6', [T_P3] = 'f8', [T_P4] = 'fb', [T_P5] = 'fa', [T_P6] = 'fc', [T_P7] = 'ff',}
tChannel[14] = {[T_O] = 'f3', [T_C] = 'f0', [T_PA] = 'f6', [T_PB] = 'fa', [T_PC] = 'fe', [T_P1] = 'f4', [T_P2] = 'f5', [T_P3] = 'fb', [T_P4] = 'f8', [T_P5] = 'f9', [T_P6] = 'ff', [T_P7] = 'fc',}
tChannel[15] = {[T_O] = 'f2', [T_C] = 'f1', [T_PA] = 'f7', [T_PB] = 'fb', [T_PC] = 'ff', [T_P1] = 'f5', [T_P2] = 'f4', [T_P3] = 'fa', [T_P4] = 'f9', [T_P5] = 'f8', [T_P6] = 'fe', [T_P7] = 'fd',}

-- ===================================
--              GLOBALS
-- ===================================
g_SerialData = ""

-- ===================================
--             FUNCTIONS
-- ===================================

-- Name: SendToSerial
-- Description: Adds debug and ID for a simpler call to send serial data
function SendToSerial(message)
  dbg("SendToSerial: " .. message)
  C4:SendToSerial(ID_SERIAL, tohex(message))
end

-- Name: ConstructMessage
-- Description: Constructs a QMotion message
-- TODO: If the end value in the table can be determined programatically, that should be done here. For now the table value will be used.
function ConstructMessage(bridgeID,channelID, command)
  channelID = tonumber(channelID)
    command = tonumber(command)

  dbg("BRIDGE ID: " .. bridgeID)
  dbg("CHANNEL: " .. channelID)
    dbg("COMMAND: " .. command)

  local endValue = bit.bxor(255,7,5,bridgeID,channelID,command)
    return string.format("01 07 00 05 %02x %02x %02x 00 %02x", bridgeID, channelID, command, endValue)
end

function ReceivedFromProxy(idBinding, strCommand, tParams)
  print("Recieved from proxy")
  --dbg(string.format("ReceivedFromProxy[%s] Command: %s", idBinding, strCommand))
  
  for k, v in pairs(tParams) do
    dbg(k .. ":" .. v)
  end    
  print("Bridge ID" .. tParams[BRIDGEID])
  print("Channel" .. tParams[CHANNEL])
  print("Command" .. tParams[COMMAND])
  if (idBinding == ID_LINK) then
    if (strCommand == SHADE_COMMAND) then 
      local strToSend = ConstructMessage(tParams[BRIDGEID], tParams[CHANNEL], tParams[COMMAND])
            SendToSerial(strToSend)
    end
  end
end

-- Name: ReceivedFromSerial
-- Description: Accumulates serial data from the binding
function ReceivedFromSerial(idBinding, strData)
  dbg(strData)
  -- Code to accumulate Serial Data
    --g_SerialData = g_SerialData or ""
    --g_SerialData = g_SerialData .. strData
end

-- Name: OnPropertyChanged
-- Description: Called when a property from Control 4 is changed for the driver
function OnPropertyChanged(strProperty)
  dbg(string.format("OnPropertyChanged[%s] set to %s", strProperty, Properties[strProperty]))

    if (strProperty == DEBUG) then
    if (Properties[DEBUG] ~= 'Off') then
      Lib.StartTimer(TIMER_DEBUG, 15, "MINUTES")
    else
      OnTimerExpired(Timers[TIMER_DEBUG])
    end
  end
end

-- Name: OnTimerExpired
-- Description: Executes appropriate actions after timers have elapsed or expired.
function OnTimerExpired(timer)
    if(Timers[TIMER_DEBUG] == timer) then
    dbg('Turning Debug Mode back to Off')
        C4:UpdateProperty(DEBUG, 'Off')
        Lib.KillTimer(TIMER_DEBUG)
  end
end

function ExecuteCommand(strCommand, tParams)
 print("Execute Command")
 end
-- Name: dbg
-- Description: Displays debug text if debugging is enabled
-- Parameters:
--        - strData: Text for debug
function dbg(strData)
  local debugText = string.format("%s: %s", os.date("[%x %X]"), strData)
  -- If debug contains print
  if (string.find(Properties[DEBUG], "Print")) then
    print(debugText)  
  end
  
  -- If debug contains log
  if (string.find(Properties[DEBUG], "Log")) then 
    C4:ErrorLog(debugText)  
  end
end

-- Name: OnDriverDestroyed
-- Description: Kills any active timers
function OnDriverDestroyed()
    Lib.KillAllTimers()
end

-- ===================================
--              Library
-- ===================================
Lib = {}

-- Name: StartTimer
-- Description: Adds the timer onto the Timers table for easy management and creates a new timer
function Lib.StartTimer(timerID, interval, unitType, bRepeat)
    interval = tonumber(interval)
    bRepeat = bRepeat or false

  Lib.KillTimer(timerID) 
  Timers[timerID] = C4:AddTimer(interval, unitType, bRepeat)
end

-- Name: KillTimer
-- Description: Kills the provided timer
function Lib.KillTimer(timerID)
    if (Timers[timerID] ~= KILLED) then 
    Timers[timerID] = C4:KillTimer(Timers[timerID])
  end
end

-- Name: KillAllTimers
-- Description: Kills all timers running in the driver
function Lib.KillAllTimers()
    for k, _ in pairs(Timers) do
    Lib.KillTimer(k)
  end
end

-- Init
for k, _ in pairs(Properties) do
    OnPropertyChanged(k)
end
